import { sharedConfig as w, createRenderEffect as E, untrack as N, splitProps as Y, createMemo as k, onCleanup as Q, $TRACK as se, batch as le, createRoot as R, createSignal as I, createResource as V, useTransition as re, createEffect as ce, mergeProps as z, createComponent as p, Suspense as fe, Show as ae, Index as ue } from "solid-js";
import { getHighlighterCore as de } from "shiki";
import './index.css';const he = [
  "allowfullscreen",
  "async",
  "autofocus",
  "autoplay",
  "checked",
  "controls",
  "default",
  "disabled",
  "formnovalidate",
  "hidden",
  "indeterminate",
  "inert",
  "ismap",
  "loop",
  "multiple",
  "muted",
  "nomodule",
  "novalidate",
  "open",
  "playsinline",
  "readonly",
  "required",
  "reversed",
  "seamless",
  "selected"
], ge = /* @__PURE__ */ new Set([
  "className",
  "value",
  "readOnly",
  "formNoValidate",
  "isMap",
  "noModule",
  "playsInline",
  ...he
]), me = /* @__PURE__ */ new Set([
  "innerHTML",
  "textContent",
  "innerText",
  "children"
]), ye = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(null), {
  className: "class",
  htmlFor: "for"
}), we = /* @__PURE__ */ Object.assign(/* @__PURE__ */ Object.create(null), {
  class: "className",
  formnovalidate: {
    $: "formNoValidate",
    BUTTON: 1,
    INPUT: 1
  },
  ismap: {
    $: "isMap",
    IMG: 1
  },
  nomodule: {
    $: "noModule",
    SCRIPT: 1
  },
  playsinline: {
    $: "playsInline",
    VIDEO: 1
  },
  readonly: {
    $: "readOnly",
    INPUT: 1,
    TEXTAREA: 1
  }
});
function xe(n, t) {
  const e = we[n];
  return typeof e == "object" ? e[t] ? e.$ : void 0 : e;
}
const be = /* @__PURE__ */ new Set([
  "beforeinput",
  "click",
  "dblclick",
  "contextmenu",
  "focusin",
  "focusout",
  "input",
  "keydown",
  "keyup",
  "mousedown",
  "mousemove",
  "mouseout",
  "mouseover",
  "mouseup",
  "pointerdown",
  "pointermove",
  "pointerout",
  "pointerover",
  "pointerup",
  "touchend",
  "touchmove",
  "touchstart"
]), Ce = /* @__PURE__ */ new Set([
  "altGlyph",
  "altGlyphDef",
  "altGlyphItem",
  "animate",
  "animateColor",
  "animateMotion",
  "animateTransform",
  "circle",
  "clipPath",
  "color-profile",
  "cursor",
  "defs",
  "desc",
  "ellipse",
  "feBlend",
  "feColorMatrix",
  "feComponentTransfer",
  "feComposite",
  "feConvolveMatrix",
  "feDiffuseLighting",
  "feDisplacementMap",
  "feDistantLight",
  "feDropShadow",
  "feFlood",
  "feFuncA",
  "feFuncB",
  "feFuncG",
  "feFuncR",
  "feGaussianBlur",
  "feImage",
  "feMerge",
  "feMergeNode",
  "feMorphology",
  "feOffset",
  "fePointLight",
  "feSpecularLighting",
  "feSpotLight",
  "feTile",
  "feTurbulence",
  "filter",
  "font",
  "font-face",
  "font-face-format",
  "font-face-name",
  "font-face-src",
  "font-face-uri",
  "foreignObject",
  "g",
  "glyph",
  "glyphRef",
  "hkern",
  "image",
  "line",
  "linearGradient",
  "marker",
  "mask",
  "metadata",
  "missing-glyph",
  "mpath",
  "path",
  "pattern",
  "polygon",
  "polyline",
  "radialGradient",
  "rect",
  "set",
  "stop",
  "svg",
  "switch",
  "symbol",
  "text",
  "textPath",
  "tref",
  "tspan",
  "use",
  "view",
  "vkern"
]), Ae = {
  xlink: "http://www.w3.org/1999/xlink",
  xml: "http://www.w3.org/XML/1998/namespace"
};
function Se(n, t, e) {
  let i = e.length, o = t.length, l = i, c = 0, s = 0, r = t[o - 1].nextSibling, d = null;
  for (; c < o || s < l; ) {
    if (t[c] === e[s]) {
      c++, s++;
      continue;
    }
    for (; t[o - 1] === e[l - 1]; )
      o--, l--;
    if (o === c) {
      const f = l < i ? s ? e[s - 1].nextSibling : e[l - s] : r;
      for (; s < l; )
        n.insertBefore(e[s++], f);
    } else if (l === s)
      for (; c < o; )
        (!d || !d.has(t[c])) && t[c].remove(), c++;
    else if (t[c] === e[l - 1] && e[s] === t[o - 1]) {
      const f = t[--o].nextSibling;
      n.insertBefore(e[s++], t[c++].nextSibling), n.insertBefore(e[--l], f), t[o] = e[l];
    } else {
      if (!d) {
        d = /* @__PURE__ */ new Map();
        let a = s;
        for (; a < l; )
          d.set(e[a], a++);
      }
      const f = d.get(t[c]);
      if (f != null)
        if (s < f && f < l) {
          let a = c, x = 1, g;
          for (; ++a < o && a < l && !((g = d.get(t[a])) == null || g !== f + x); )
            x++;
          if (x > f - s) {
            const y = t[c];
            for (; s < f; )
              n.insertBefore(e[s++], y);
          } else
            n.replaceChild(e[s++], t[c++]);
        } else
          c++;
      else
        t[c++].remove();
    }
  }
}
const B = "_$DX_DELEGATE";
function Te(n, t, e) {
  let i;
  const o = () => {
    const c = document.createElement("template");
    return c.innerHTML = n, c.content.firstChild;
  }, l = () => (i || (i = o())).cloneNode(!0);
  return l.cloneNode = l, l;
}
function J(n, t = window.document) {
  const e = t[B] || (t[B] = /* @__PURE__ */ new Set());
  for (let i = 0, o = n.length; i < o; i++) {
    const l = n[i];
    e.has(l) || (e.add(l), t.addEventListener(l, ke));
  }
}
function O(n, t, e) {
  w.context && n.isConnected || (e == null ? n.removeAttribute(t) : n.setAttribute(t, e));
}
function Ee(n, t, e, i) {
  w.context && n.isConnected || (i == null ? n.removeAttributeNS(t, e) : n.setAttributeNS(t, e, i));
}
function P(n, t) {
  w.context && n.isConnected || (t == null ? n.removeAttribute("class") : n.className = t);
}
function pe(n, t, e, i) {
  if (i)
    Array.isArray(e) ? (n[`$$${t}`] = e[0], n[`$$${t}Data`] = e[1]) : n[`$$${t}`] = e;
  else if (Array.isArray(e)) {
    const o = e[0];
    n.addEventListener(t, e[0] = (l) => o.call(n, e[1], l));
  } else
    n.addEventListener(t, e);
}
function Me(n, t, e = {}) {
  const i = Object.keys(t || {}), o = Object.keys(e);
  let l, c;
  for (l = 0, c = o.length; l < c; l++) {
    const s = o[l];
    !s || s === "undefined" || t[s] || (G(n, s, !1), delete e[s]);
  }
  for (l = 0, c = i.length; l < c; l++) {
    const s = i[l], r = !!t[s];
    !s || s === "undefined" || e[s] === r || !r || (G(n, s, !0), e[s] = r);
  }
  return e;
}
function $e(n, t, e) {
  if (!t)
    return e ? O(n, "style") : t;
  const i = n.style;
  if (typeof t == "string")
    return i.cssText = t;
  typeof e == "string" && (i.cssText = e = void 0), e || (e = {}), t || (t = {});
  let o, l;
  for (l in e)
    t[l] == null && i.removeProperty(l), delete e[l];
  for (l in t)
    o = t[l], o !== e[l] && (i.setProperty(l, o), e[l] = o);
  return e;
}
function Z(n, t = {}, e, i) {
  const o = {};
  return i || E(
    () => o.children = _(n, t.children, o.children)
  ), E(
    () => typeof t.ref == "function" ? ee(t.ref, n) : t.ref = n
  ), E(() => _e(n, t, e, !0, o, !0)), o;
}
function ee(n, t, e) {
  return N(() => n(t, e));
}
function Ne(n, t, e, i) {
  if (e !== void 0 && !i && (i = []), typeof t != "function")
    return _(n, t, i, e);
  E((o) => _(n, t(), o, e), i);
}
function _e(n, t, e, i, o = {}, l = !1) {
  t || (t = {});
  for (const c in o)
    if (!(c in t)) {
      if (c === "children")
        continue;
      o[c] = H(n, c, null, o[c], e, l);
    }
  for (const c in t) {
    if (c === "children")
      continue;
    const s = t[c];
    o[c] = H(n, c, s, o[c], e, l);
  }
}
function Le(n) {
  let t, e;
  return !w.context || !(t = w.registry.get(e = Ie())) ? n() : (w.completed && w.completed.add(t), w.registry.delete(e), t);
}
function Pe(n) {
  return n.toLowerCase().replace(/-([a-z])/g, (t, e) => e.toUpperCase());
}
function G(n, t, e) {
  const i = t.trim().split(/\s+/);
  for (let o = 0, l = i.length; o < l; o++)
    n.classList.toggle(i[o], e);
}
function H(n, t, e, i, o, l) {
  let c, s, r, d, f;
  if (t === "style")
    return $e(n, e, i);
  if (t === "classList")
    return Me(n, e, i);
  if (e === i)
    return i;
  if (t === "ref")
    l || e(n);
  else if (t.slice(0, 3) === "on:") {
    const a = t.slice(3);
    i && n.removeEventListener(a, i), e && n.addEventListener(a, e);
  } else if (t.slice(0, 10) === "oncapture:") {
    const a = t.slice(10);
    i && n.removeEventListener(a, i, !0), e && n.addEventListener(a, e, !0);
  } else if (t.slice(0, 2) === "on") {
    const a = t.slice(2).toLowerCase(), x = be.has(a);
    if (!x && i) {
      const g = Array.isArray(i) ? i[0] : i;
      n.removeEventListener(a, g);
    }
    (x || e) && (pe(n, a, e, x), x && J([a]));
  } else if (t.slice(0, 5) === "attr:")
    O(n, t.slice(5), e);
  else if ((f = t.slice(0, 5) === "prop:") || (r = me.has(t)) || !o && ((d = xe(t, n.tagName)) || (s = ge.has(t))) || (c = n.nodeName.includes("-"))) {
    if (f)
      t = t.slice(5), s = !0;
    else if (w.context && n.isConnected)
      return e;
    t === "class" || t === "className" ? P(n, e) : c && !s && !r ? n[Pe(t)] = e : n[d || t] = e;
  } else {
    const a = o && t.indexOf(":") > -1 && Ae[t.split(":")[0]];
    a ? Ee(n, a, t, e) : O(n, ye[t] || t, e);
  }
  return e;
}
function ke(n) {
  const t = `$$${n.type}`;
  let e = n.composedPath && n.composedPath()[0] || n.target;
  for (n.target !== e && Object.defineProperty(n, "target", {
    configurable: !0,
    value: e
  }), Object.defineProperty(n, "currentTarget", {
    configurable: !0,
    get() {
      return e || document;
    }
  }), w.registry && !w.done && (w.done = _$HY.done = !0); e; ) {
    const i = e[t];
    if (i && !e.disabled) {
      const o = e[`${t}Data`];
      if (o !== void 0 ? i.call(e, o, n) : i.call(e, n), n.cancelBubble)
        return;
    }
    e = e._$host || e.parentNode || e.host;
  }
}
function _(n, t, e, i, o) {
  const l = !!w.context && n.isConnected;
  if (l) {
    !e && (e = [...n.childNodes]);
    let r = [];
    for (let d = 0; d < e.length; d++) {
      const f = e[d];
      f.nodeType === 8 && f.data.slice(0, 2) === "!$" ? f.remove() : r.push(f);
    }
    e = r;
  }
  for (; typeof e == "function"; )
    e = e();
  if (t === e)
    return e;
  const c = typeof t, s = i !== void 0;
  if (n = s && e[0] && e[0].parentNode || n, c === "string" || c === "number") {
    if (l)
      return e;
    if (c === "number" && (t = t.toString()), s) {
      let r = e[0];
      r && r.nodeType === 3 ? r.data !== t && (r.data = t) : r = document.createTextNode(t), e = M(n, e, i, r);
    } else
      e !== "" && typeof e == "string" ? e = n.firstChild.data = t : e = n.textContent = t;
  } else if (t == null || c === "boolean") {
    if (l)
      return e;
    e = M(n, e, i);
  } else {
    if (c === "function")
      return E(() => {
        let r = t();
        for (; typeof r == "function"; )
          r = r();
        e = _(n, r, e, i);
      }), () => e;
    if (Array.isArray(t)) {
      const r = [], d = e && Array.isArray(e);
      if (j(r, t, e, o))
        return E(() => e = _(n, r, e, i, !0)), () => e;
      if (l) {
        if (!r.length)
          return e;
        if (i === void 0)
          return [...n.childNodes];
        let f = r[0], a = [f];
        for (; (f = f.nextSibling) !== i; )
          a.push(f);
        return e = a;
      }
      if (r.length === 0) {
        if (e = M(n, e, i), s)
          return e;
      } else
        d ? e.length === 0 ? F(n, r, i) : Se(n, e, r) : (e && M(n), F(n, r));
      e = r;
    } else if (t.nodeType) {
      if (l && t.parentNode)
        return e = s ? [t] : t;
      if (Array.isArray(e)) {
        if (s)
          return e = M(n, e, i, t);
        M(n, e, null, t);
      } else
        e == null || e === "" || !n.firstChild ? n.appendChild(t) : n.replaceChild(t, n.firstChild);
      e = t;
    }
  }
  return e;
}
function j(n, t, e, i) {
  let o = !1;
  for (let l = 0, c = t.length; l < c; l++) {
    let s = t[l], r = e && e[n.length], d;
    if (!(s == null || s === !0 || s === !1))
      if ((d = typeof s) == "object" && s.nodeType)
        n.push(s);
      else if (Array.isArray(s))
        o = j(n, s, r) || o;
      else if (d === "function")
        if (i) {
          for (; typeof s == "function"; )
            s = s();
          o = j(
            n,
            Array.isArray(s) ? s : [s],
            Array.isArray(r) ? r : [r]
          ) || o;
        } else
          n.push(s), o = !0;
      else {
        const f = String(s);
        r && r.nodeType === 3 && r.data === f ? n.push(r) : n.push(document.createTextNode(f));
      }
  }
  return o;
}
function F(n, t, e = null) {
  for (let i = 0, o = t.length; i < o; i++)
    n.insertBefore(t[i], e);
}
function M(n, t, e, i) {
  if (e === void 0)
    return n.textContent = "";
  const o = i || document.createTextNode("");
  if (t.length) {
    let l = !1;
    for (let c = t.length - 1; c >= 0; c--) {
      const s = t[c];
      if (o !== s) {
        const r = s.parentNode === n;
        !l && !c ? r ? n.replaceChild(o, s) : n.insertBefore(o, e) : r && s.remove();
      } else
        l = !0;
    }
  } else
    n.insertBefore(o, e);
  return [o];
}
function Ie() {
  const n = w.context;
  return `${n.id}${n.count++}`;
}
const Oe = "http://www.w3.org/2000/svg";
function Ve(n, t = !1) {
  return t ? document.createElementNS(Oe, n) : document.createElement(n);
}
function ve(n) {
  const [t, e] = Y(n, ["component"]), i = k(() => t.component);
  return k(() => {
    const o = i();
    switch (typeof o) {
      case "function":
        return N(() => o(e));
      case "string":
        const l = Ce.has(o), c = w.context ? Le() : Ve(o, l);
        return Z(c, e, l), c;
    }
  });
}
function U(n) {
  var t;
  for (let e = 0; e < n.length; e++)
    (t = n[e]) == null || t.disposer();
}
function je(n, t, e = {}) {
  const i = [];
  let o = [], l, c, s, r, d, f, a, x, g;
  return Q(() => {
    g == null || g(), g = void 0, U(i);
  }), () => {
    const h = n() || [];
    return h[se], N(() => {
      var S, T, $, D;
      h.length > 0 && g && (g(), g = void 0, x = void 0);
      const u = new Array(h.length);
      for (l = i.length, s = l - 1; s >= 0; --s)
        r = i[s], f = r.index, f < h.length && h[f] === r.value && (u[f] = o[f], --l !== s && (i[s] = i[l], i[l] = r));
      const m = /* @__PURE__ */ new Map(), C = new Uint8Array(l);
      for (s = l - 1; s >= 0; --s)
        d = i[s].value, ((S = m.get(d)) == null ? void 0 : S.push(s)) ?? m.set(d, [s]);
      for (c = 0; c < h.length; ++c)
        c in u || (a = h[c], s = ((T = m.get(a)) == null ? void 0 : T.pop()) ?? -1, s >= 0 && (r = i[s], f = r.index, u[c] = o[f], r.index = c, ($ = r.indexSetter) == null || $.call(r, c), C[s] = 1));
      for (s = C.length - 1; s >= 0; --s)
        C[s] && --l !== s && (r = i[s], i[s] = i[l], i[l] = r);
      for (s = l - 1; s >= 0; --s)
        r = i[s], f = r.index, !(f in u) && f < h.length && (u[f] = o[f], a = h[f], r.value = a, (D = r.valueSetter) == null || D.call(r, y), --l !== s && (i[s] = i[l], i[l] = r));
      for (c = 0; c < h.length; ++c)
        c in u || (a = h[c], l > 0 ? (r = i[--l], u[c] = o[r.index], le(b)) : u[c] = R(A));
      return U(i.splice(0, l)), h.length === 0 && e.fallback ? (g || (x = [
        R((oe) => (g = oe, e.fallback()))
      ]), x) : o = u;
    });
  };
  function y() {
    return a;
  }
  function b() {
    var h, u;
    r.index = c, (h = r.indexSetter) == null || h.call(r, c), r.value = a, (u = r.valueSetter) == null || u.call(r, y);
  }
  function A(h) {
    const u = {
      value: a,
      index: c,
      disposer: h
    }, m = a, C = c;
    i.push(u);
    let S = () => ([S, u.valueSetter] = I(m, { name: "value" }), S()), T = () => ([T, u.indexSetter] = I(C, { name: "index" }), T());
    return t(
      () => S(),
      () => T()
    );
  }
}
function De(n) {
  const t = "fallback" in n && { fallback: () => n.fallback };
  return k(
    je(() => n.each, n.children, t || void 0),
    void 0,
    { name: "value" }
  );
}
function te(n) {
  var t, e, i = "";
  if (typeof n == "string" || typeof n == "number")
    i += n;
  else if (typeof n == "object")
    if (Array.isArray(n)) {
      var o = n.length;
      for (t = 0; t < o; t++)
        n[t] && (e = te(n[t])) && (i && (i += " "), i += e);
    } else
      for (e in n)
        n[e] && (i && (i += " "), i += e);
  return i;
}
function Re() {
  for (var n, t, e = 0, i = "", o = arguments.length; e < o; e++)
    (n = arguments[e]) && (t = te(n)) && (i && (i += " "), i += t);
  return i;
}
const Be = "index-module__editor___WoVwR", Ge = "index-module__container___GdQY1", He = "index-module__character___mhd0f", Fe = "index-module__textarea___cMW-q", L = {
  editor: Be,
  container: Ge,
  character: He,
  textarea: Fe
};
function Ue(n) {
  let t = parseInt(n.slice(1), 16), e = t >> 16 & 255, i = t >> 8 & 255, o = t & 255;
  return [e, i, o];
}
function Ke(n, t, e) {
  n /= 255, t /= 255, e /= 255;
  const i = Math.max(n, t, e), o = Math.min(n, t, e);
  let l = (i + o) / 2, c = (i + o) / 2, s = (i + o) / 2;
  if (i === o)
    l = c = 0;
  else {
    const r = i - o;
    switch (c = s > 0.5 ? r / (2 - i - o) : r / (i + o), i) {
      case n:
        l = (t - e) / r + (t < e ? 6 : 0);
        break;
      case t:
        l = (e - n) / r + 2;
        break;
      case e:
        l = (n - t) / r + 4;
        break;
    }
    l /= 6;
  }
  return [l, c, s];
}
function We(n, t, e) {
  let i, o, l;
  if (t === 0)
    i = o = l = e;
  else {
    const c = (d, f, a) => (a < 0 && (a += 1), a > 1 && (a -= 1), a < 0.16666666666666666 ? d + (f - d) * 6 * a : a < 0.5 ? f : a < 0.6666666666666666 ? d + (f - d) * (0.6666666666666666 - a) * 6 : d), s = e < 0.5 ? e * (1 + t) : e + t - e * t, r = 2 * e - s;
    i = c(r, s, n + 1 / 3), o = c(r, s, n), l = c(r, s, n - 1 / 3);
  }
  return [Math.round(i * 255), Math.round(o * 255), Math.round(l * 255)];
}
function K(n, t, e) {
  const i = [n, t, e].map((o) => (o /= 255, o <= 0.03928 ? o / 12.92 : Math.pow((o + 0.055) / 1.055, 2.4)));
  return i[0] * 0.2126 + i[1] * 0.7152 + i[2] * 0.0722;
}
function Xe(n, t) {
  const e = K(...n), i = K(...t), o = Math.max(e, i), l = Math.min(e, i);
  return (o + 0.05) / (l + 0.05);
}
const W = /* @__PURE__ */ new Map();
function qe(n) {
  const t = W.get(n);
  if (t)
    return t;
  const e = Ue(n);
  let i = e, o = Ke(i[0], i[1], i[2]);
  const l = o[2] < 0.5;
  let c = 0, s = 0;
  for (; s < 200 && (o[2] += l ? 1e-3 : -1e-3, !(o[2] <= 0 || o[2] >= 1 || (i = We(o[0], o[1], o[2]), c = Xe(i, e), c > 4.5))); )
    s++;
  const r = `#${((1 << 24) + (i[0] << 16) + (i[1] << 8) + i[2]).toString(16).slice(1).toUpperCase()}`;
  return W.set(n, r), r;
}
function ne(n, t, e) {
  const i = typeof n == "function" ? n() : n;
  return i ? t(i) : e ? e() : void 0;
}
function Ye(n, t, e) {
  return () => ne(n, t, e);
}
function X(...n) {
  function t() {
    const e = new Array(n.length);
    for (let i = 0; i < n.length; i++) {
      const o = typeof n[i] == "function" ? n[i]() : n[i];
      if (!o)
        return;
      e[i] = o;
    }
    return e;
  }
  return t;
}
function Qe(n) {
  return n.split(`
`).length;
}
function ze(n) {
  let t = -1 / 0;
  return n.split(`
`).forEach((e) => {
    e.length > t && (t = e.length);
  }), t;
}
var Je = /* @__PURE__ */ Te("<div><div><textarea inputmode=none autocomplete=off></textarea><code aria-hidden>");
async function q(n) {
  if (n instanceof Promise) {
    const t = await n;
    return "default" in t ? t.default : t;
  }
  return n;
}
const Ze = import("./wasm-SPaT1zC5.js"), v = /* @__PURE__ */ new WeakMap();
function et([n, t]) {
  let e = v.get(n);
  e || (v.set(n, /* @__PURE__ */ new WeakMap()), e = v.get(n));
  let i = e.get(t);
  return i || (i = de({
    themes: [n],
    langs: [t],
    loadWasm: Ze
  }), e.set(t, i)), i;
}
function it(n) {
  const [t, e] = Y(n, ["class", "defaultValue", "lang", "onInput", "value", "style", "theme"]), [i, o] = I(t.defaultValue || t.value), [l, c] = I({
    width: 0,
    height: 0
  }), [s] = V(() => t.theme, q), [r] = V(() => t.lang, q), [d] = V(X(s, r), et), f = k((y) => {
    var C;
    const b = d(), A = (C = N(r)) == null ? void 0 : C[0], h = N(s);
    if (!b || !A || !h)
      return y;
    const u = i();
    if (!i)
      return;
    const m = b.codeToHast(u, {
      lang: A.name,
      theme: h
    });
    return m.children[0] ? m.children[0] : y;
  }), a = Ye(X(s, d), ([y, b]) => {
    const {
      fg: A,
      bg: h
    } = b.getTheme(y);
    return {
      "--theme-selection-color": qe(h),
      "--theme-background-color": h,
      "--theme-foreground-color": A
    };
  }), [, x] = re();
  function g(y) {
    x(() => o(y));
  }
  return ce(() => g(t.value)), (() => {
    var y = Je(), b = y.firstChild, A = b.firstChild, h = A.nextSibling;
    return Z(y, z({
      get class() {
        return Re(L.editor, t.class);
      },
      get style() {
        return {
          ...a(),
          ...t.style
        };
      }
    }, e), !1, !0), Ne(b, p(fe, {
      get children() {
        return p(De, {
          get each() {
            return ne(f, (u) => "children" in u && u.children);
          },
          children: (u) => p(ie, {
            get node() {
              return u();
            }
          })
        });
      }
    }), A), A.$$input = ({
      currentTarget: {
        value: u
      }
    }) => {
      var m;
      g(u), (m = t.onInput) == null || m.call(t, u);
    }, O(A, "spellcheck", !1), ee((u) => {
      const m = new ResizeObserver(([C]) => {
        c(C.contentRect);
      });
      m.observe(u), Q(() => m.disconnect());
    }, h), h.innerHTML = "&nbsp;", E((u) => {
      var m = L.container, C = `${Math.ceil(ze(i()) * l().width + 1)}px`, S = `${Math.ceil(Qe(i()) * l().height)}px`, T = L.textarea, $ = L.character;
      return m !== u.e && P(b, u.e = m), C !== u.t && ((u.t = C) != null ? b.style.setProperty("min-width", C) : b.style.removeProperty("min-width")), S !== u.a && ((u.a = S) != null ? b.style.setProperty("min-height", S) : b.style.removeProperty("min-height")), T !== u.o && P(A, u.o = T), $ !== u.i && P(h, u.i = $), u;
    }, {
      e: void 0,
      t: void 0,
      a: void 0,
      o: void 0,
      i: void 0
    }), E(() => A.value = t.value), y;
  })();
}
function ie(n) {
  return p(ae, {
    get when() {
      return n.node.type !== "text" && n.node;
    },
    get fallback() {
      return n.node.value;
    },
    children: (t) => p(ve, z({
      get component() {
        return t().tagName || "div";
      }
    }, () => t().properties, {
      get children() {
        return p(ue, {
          get each() {
            return t().children;
          },
          children: (e) => p(ie, {
            get node() {
              return e();
            }
          })
        });
      }
    }))
  });
}
J(["input"]);
export {
  it as ShikiTextarea
};
